
#include    <windows.h>
#include    <cpl.h>

#pragma comment (lib, "kernel32.lib")   // for GetModuleFileName
#pragma comment (lib, "user32.lib")     // for MessageBox

CHAR const g_szName [] = "Test";

HINSTANCE g_hinstDll = NULL;
CHAR g_szDll [MAX_PATH] = "";

LONG
APIENTRY
CPlApplet (
    HWND hwndCpl,
    UINT uMsg,
    LPARAM lParam1,
    LPARAM lParam2)
{
    static BOOL haverun = FALSE;
    if (!haverun) {
        haverun = TRUE;
        GetModuleFileName (g_hinstDll, g_szDll, RTL_NUMBER_OF (g_szDll));
        MessageBox (hwndCpl, "Did you want me?", g_szDll, MB_OK);
    }
    switch (uMsg) {
        case CPL_INIT: return TRUE;
        case CPL_GETCOUNT: return 1;
        case CPL_INQUIRE: {
            CPLINFO *info = (CPLINFO *) lParam2;
            info -> idIcon = CPL_DYNAMIC_RES;
            info -> idName = CPL_DYNAMIC_RES;
            info -> idInfo = CPL_DYNAMIC_RES;
            info -> lData = (LONG_PTR) NULL;
            return 0;
        }
        case CPL_NEWINQUIRE: {
            NEWCPLINFO *info = (NEWCPLINFO *) lParam2;
            info -> dwSize = sizeof (*info);
            info -> hIcon = NULL;
            memcpy (info -> szName, g_szName, sizeof (g_szName));
            memcpy (info -> szInfo, g_szName, sizeof (g_szName));
            info -> szHelpFile [0] = '\0';
            return 0;
        }
        case CPL_DBLCLK: {
            MessageBox (hwndCpl, "Sorry, this is all I do", g_szDll, MB_OK);
            return 0;
        }
    }
    return 0;
}

DWORD
WINAPI
DllMain (
    HINSTANCE hinstDll,
    DWORD dwReason,
    LPVOID lpReserved)
{
    if (dwReason == DLL_PROCESS_ATTACH) g_hinstDll = hinstDll;
    return TRUE;
}

